#include <windows.h>
#include <commctrl.h>
#include <winsock.h>
#include "wimpck.h"
#include "vector.h"
#include "fileinfo.h"
#include "cddb.h"

int
cddb_sum(int n)
{
	int	ret;

	/* For backward compatibility this algorithm must not change */

	ret = 0;

	while (n > 0) {
		ret = ret + (n % 10);
		n = n / 10;
	}

	return (ret);
}

// HTTP GET request and read reponse
// if result argument is NULL no result reading is done
// returns nonzero on failure

int MakeHTTPRequest(char *URL, char *message, char * result, int resultsize)
{
	WORD wVersionRequested = MAKEWORD(1,1);
	WSADATA wsaData;
	int nRet,c,c2;
	short nPort;
    LPHOSTENT lpHostEntry;
	char szBuf[1024];
	char szServer[1024];
	char szPath[1024];
	char * temp;
	SOCKET	theSocket;
	SOCKADDR_IN saServer;

	nPort = 80;

	// parse URL
	if (strstr(URL,"http://")==URL) c=7;
	else c=0;
	for (c2=0; c < strlen(URL) && URL[c] != '/'; c++,c2++) szServer[c2]=URL[c];
	szServer[c2]='\0';
	for (c2=0; c < strlen(URL); c++,c2++) szPath[c2]=URL[c];
	szPath[c2]='\0';

	//
	// Initialize WinSock and check the version
	//
	nRet = WSAStartup(wVersionRequested, &wsaData);
	if (wsaData.wVersion != wVersionRequested)
	{	
		return 1;
	}


	//
	// Go do the stuff a stream client does
	//

	//
	// Find the server
	//

	lpHostEntry = gethostbyname(szServer);
    if (lpHostEntry == NULL)
    {
        //PRINTERROR("gethostbyname()");
        return 1;
    }

	//
	// Create a TCP/IP stream socket
	//

	theSocket = socket(AF_INET,				// Address family
					   SOCK_STREAM,			// Socket type
					   IPPROTO_TCP);		// Protocol
	if (theSocket == INVALID_SOCKET)
	{
		//PRINTERROR("socket()");
		return 1;
	}

	//
	// Fill in the address structure
	//

	saServer.sin_family = AF_INET;
	saServer.sin_addr = *((LPIN_ADDR)*lpHostEntry->h_addr_list);
										// ^ Server's address
	saServer.sin_port = htons(nPort);	// Port number from command line

	//
	// connect to the server
	//

	nRet = connect(theSocket,				// Socket
				   (LPSOCKADDR)&saServer,	// Server address
				   sizeof(struct sockaddr));// Length of server address structure
	if (nRet == SOCKET_ERROR)
	{
		//PRINTERROR("socket()");
		closesocket(theSocket);
		return 1;
	}


	//
	// Send data to the server
	//
	
	sprintf(szBuf,"GET %s?%s HTTP/1.0\n\n",szPath,message);
	free(temp);
	nRet = send(theSocket,				// Connected socket
				szBuf,					// Data buffer
				strlen(szBuf),			// Length of data
				0);						// Flags
	if (nRet == SOCKET_ERROR)
	{
		//PRINTERROR("send()");
		closesocket(theSocket);
		return 1;
	}


	// read response
	if (result) {

		nRet = recv(theSocket,
					result,
					resultsize,
					0);

		if (nRet == SOCKET_ERROR) {
			closesocket(theSocket);
			return 1;
		}

		result[nRet]='\0';
	}

	closesocket(theSocket);

	WSACleanup();

	return 0;
}